Index: /trunk/sources/HeuristicLab.Algorithms.SGA/3.3/Tests/HeuristicLab.Algorithms.SGA-3.3.Tests.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.SGA/3.3/Tests/HeuristicLab.Algorithms.SGA-3.3.Tests.csproj	(revision 3053)
+++ /trunk/sources/HeuristicLab.Algorithms.SGA/3.3/Tests/HeuristicLab.Algorithms.SGA-3.3.Tests.csproj	(revision 3054)
@@ -78,4 +78,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\..\HeuristicLab.Algorithms.TS\3.3\HeuristicLab.Algorithms.TS-3.3.csproj">
+      <Project>{D58A232D-04BA-4186-B73E-0EC86FD31ABE}</Project>
+      <Name>HeuristicLab.Algorithms.TS-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj">
       <Project>{887425B4-4348-49ED-A457-B7D2C26DDBF9}</Project>
Index: /trunk/sources/HeuristicLab.Data/3.3/BoolArray.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/BoolArray.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/BoolArray.cs	(revision 3054)
@@ -28,23 +28,16 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class BoolArray : ValueTypeArray<bool>, IStringConvertibleArray {
+  public class BoolArray : ValueTypeArray<bool>, IStringConvertibleArray {
     public BoolArray() : base() { }
     public BoolArray(int length) : base(length) { }
     public BoolArray(bool[] elements) : base(elements) { }
-    private BoolArray(BoolArray elements) : base(elements) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      BoolArray clone = new BoolArray(this);
+      BoolArray clone = new BoolArray(array);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    #region IStringConvertibleArray Members
-    int IStringConvertibleArray.Length {
-      get { return Length; }
-      set { Length = value; }
-    }
-
-    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       bool val;
       bool valid = bool.TryParse(value, out val);
@@ -59,8 +52,8 @@
       return valid;
     }
-    string IStringConvertibleArray.GetValue(int index) {
+    protected virtual string GetValue(int index) {
       return this[index].ToString();
     }
-    bool IStringConvertibleArray.SetValue(string value, int index) {
+    protected virtual bool SetValue(string value, int index) {
       bool val;
       if (bool.TryParse(value, out val)) {
@@ -71,4 +64,19 @@
       }
     }
+
+    #region IStringConvertibleArray Members
+    int IStringConvertibleArray.Length {
+      get { return Length; }
+      set { Length = value; }
+    }
+    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleArray.GetValue(int index) {
+      return GetValue(index);
+    }
+    bool IStringConvertibleArray.SetValue(string value, int index) {
+      return SetValue(value, index);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/BoolMatrix.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/BoolMatrix.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/BoolMatrix.cs	(revision 3054)
@@ -28,27 +28,16 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class BoolMatrix : ValueTypeMatrix<bool>, IStringConvertibleMatrix {
+  public class BoolMatrix : ValueTypeMatrix<bool>, IStringConvertibleMatrix {
     public BoolMatrix() : base() { }
     public BoolMatrix(int rows, int columns) : base(rows, columns) { }
     public BoolMatrix(bool[,] elements) : base(elements) { }
-    private BoolMatrix(BoolMatrix elements) : base(elements) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      BoolMatrix clone = new BoolMatrix(this);
+      BoolMatrix clone = new BoolMatrix(matrix);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    #region IStringConvertibleMatrix Members
-    int IStringConvertibleMatrix.Rows {
-      get { return Rows; }
-      set { Rows = value; }
-    }
-    int IStringConvertibleMatrix.Columns {
-      get { return Columns; }
-      set { Columns = value; }
-    }
-
-    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       bool val;
       bool valid = bool.TryParse(value, out val);
@@ -63,8 +52,8 @@
       return valid;
     }
-    string IStringConvertibleMatrix.GetValue(int rowIndex, int columIndex) {
+    protected virtual string GetValue(int rowIndex, int columIndex) {
       return this[rowIndex, columIndex].ToString();
     }
-    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+    protected virtual bool SetValue(string value, int rowIndex, int columnIndex) {
       bool val;
       if (bool.TryParse(value, out val)) {
@@ -75,4 +64,23 @@
       }
     }
+
+    #region IStringConvertibleMatrix Members
+    int IStringConvertibleMatrix.Rows {
+      get { return Rows; }
+      set { Rows = value; }
+    }
+    int IStringConvertibleMatrix.Columns {
+      get { return Columns; }
+      set { Columns = value; }
+    }
+    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleMatrix.GetValue(int rowIndex, int columIndex) {
+      return GetValue(rowIndex, columIndex);
+    }
+    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+      return SetValue(value, rowIndex, columnIndex);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/BoolValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/BoolValue.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/BoolValue.cs	(revision 3054)
@@ -29,15 +29,15 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class BoolValue : ValueTypeValue<bool>, IComparable, IStringConvertibleValue {
+  public class BoolValue : ValueTypeValue<bool>, IComparable, IStringConvertibleValue {
     public BoolValue() : base() { }
     public BoolValue(bool value) : base(value) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      BoolValue clone = new BoolValue(Value);
+      BoolValue clone = new BoolValue(value);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    public int CompareTo(object obj) {
+    public virtual int CompareTo(object obj) {
       BoolValue other = obj as BoolValue;
       if (other != null)
@@ -47,6 +47,5 @@
     }
 
-    #region IStringConvertibleValue Members
-    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       bool val;
       bool valid = bool.TryParse(value, out val);
@@ -61,8 +60,8 @@
       return valid;
     }
-    string IStringConvertibleValue.GetValue() {
+    protected virtual string GetValue() {
       return Value.ToString();
     }
-    bool IStringConvertibleValue.SetValue(string value) {
+    protected virtual bool SetValue(string value) {
       bool val;
       if (bool.TryParse(value, out val)) {
@@ -73,4 +72,15 @@
       }
     }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/Comparison.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/Comparison.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/Comparison.cs	(revision 3054)
@@ -28,15 +28,15 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class Comparison : ValueTypeValue<ComparisonType>, IComparable {
+  public class Comparison : ValueTypeValue<ComparisonType>, IComparable {
     public Comparison() : base() { }
     public Comparison(ComparisonType value) : base(value) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      Comparison clone = new Comparison(Value);
+      Comparison clone = new Comparison(value);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    public int CompareTo(object obj) {
+    public virtual int CompareTo(object obj) {
       Comparison other = obj as Comparison;
       if (other != null)
Index: /trunk/sources/HeuristicLab.Data/3.3/DateTimeValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/DateTimeValue.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/DateTimeValue.cs	(revision 3054)
@@ -28,10 +28,10 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class DateTimeValue : ValueTypeValue<DateTime>, IComparable, IStringConvertibleValue {
+  public class DateTimeValue : ValueTypeValue<DateTime>, IComparable, IStringConvertibleValue {
     public DateTimeValue() : base() { }
     public DateTimeValue(DateTime value) : base(value) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      DateTimeValue clone = new DateTimeValue(Value);
+      DateTimeValue clone = new DateTimeValue(value);
       cloner.RegisterClonedObject(this, clone);
       return clone;
@@ -42,5 +42,5 @@
     }
 
-    public int CompareTo(object obj) {
+    public virtual int CompareTo(object obj) {
       DateTimeValue other = obj as DateTimeValue;
       if (other != null)
@@ -50,6 +50,5 @@
     }
 
-    #region IStringConvertibleValue Members
-    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       DateTime val;
       bool valid = DateTime.TryParse(value, out val);
@@ -57,8 +56,8 @@
       return valid;
     }
-    string IStringConvertibleValue.GetValue() {
+    protected virtual string GetValue() {
       return Value.ToString("o");  // round-trip format
     }
-    bool IStringConvertibleValue.SetValue(string value) {
+    protected virtual bool SetValue(string value) {
       DateTime val;
       if (DateTime.TryParse(value, out val)) {
@@ -69,4 +68,15 @@
       }
     }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/DoubleArray.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/DoubleArray.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/DoubleArray.cs	(revision 3054)
@@ -28,23 +28,16 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class DoubleArray : ValueTypeArray<double>, IStringConvertibleArray {
+  public class DoubleArray : ValueTypeArray<double>, IStringConvertibleArray {
     public DoubleArray() : base() { }
     public DoubleArray(int length) : base(length) { }
     public DoubleArray(double[] elements) : base(elements) { }
-    private DoubleArray(DoubleArray elements) : base(elements) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      DoubleArray clone = new DoubleArray(this);
+      DoubleArray clone = new DoubleArray(array);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    #region IStringConvertibleArray Members
-    int IStringConvertibleArray.Length {
-      get { return Length; }
-      set { Length = value; }
-    }
-
-    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       double val;
       bool valid = double.TryParse(value, out val);
@@ -59,8 +52,8 @@
       return valid;
     }
-    string IStringConvertibleArray.GetValue(int index) {
+    protected virtual string GetValue(int index) {
       return this[index].ToString();
     }
-    bool IStringConvertibleArray.SetValue(string value, int index) {
+    protected virtual bool SetValue(string value, int index) {
       double val;
       if (double.TryParse(value, out val)) {
@@ -71,4 +64,19 @@
       }
     }
+
+    #region IStringConvertibleArray Members
+    int IStringConvertibleArray.Length {
+      get { return Length; }
+      set { Length = value; }
+    }
+    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleArray.GetValue(int index) {
+      return GetValue(index);
+    }
+    bool IStringConvertibleArray.SetValue(string value, int index) {
+      return SetValue(value, index);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/DoubleMatrix.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/DoubleMatrix.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/DoubleMatrix.cs	(revision 3054)
@@ -28,27 +28,16 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class DoubleMatrix : ValueTypeMatrix<double>, IStringConvertibleMatrix {
+  public class DoubleMatrix : ValueTypeMatrix<double>, IStringConvertibleMatrix {
     public DoubleMatrix() : base() { }
     public DoubleMatrix(int rows, int columns) : base(rows, columns) { }
     public DoubleMatrix(double[,] elements) : base(elements) { }
-    private DoubleMatrix(DoubleMatrix elements) : base(elements) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      DoubleMatrix clone = new DoubleMatrix(this);
+      DoubleMatrix clone = new DoubleMatrix(matrix);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    #region IStringConvertibleMatrix Members
-    int IStringConvertibleMatrix.Rows {
-      get { return Rows; }
-      set { Rows = value; }
-    }
-    int IStringConvertibleMatrix.Columns {
-      get { return Columns; }
-      set { Columns = value; }
-    }
-
-    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       double val;
       bool valid = double.TryParse(value, out val);
@@ -63,8 +52,8 @@
       return valid;
     }
-    string IStringConvertibleMatrix.GetValue(int rowIndex, int columIndex) {
+    protected virtual string GetValue(int rowIndex, int columIndex) {
       return this[rowIndex, columIndex].ToString();
     }
-    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+    protected virtual bool SetValue(string value, int rowIndex, int columnIndex) {
       double val;
       if (double.TryParse(value, out val)) {
@@ -75,4 +64,23 @@
       }
     }
+
+    #region IStringConvertibleMatrix Members
+    int IStringConvertibleMatrix.Rows {
+      get { return Rows; }
+      set { Rows = value; }
+    }
+    int IStringConvertibleMatrix.Columns {
+      get { return Columns; }
+      set { Columns = value; }
+    }
+    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleMatrix.GetValue(int rowIndex, int columIndex) {
+      return GetValue(rowIndex, columIndex);
+    }
+    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+      return SetValue(value, rowIndex, columnIndex);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/DoubleValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 3054)
@@ -29,10 +29,10 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class DoubleValue : ValueTypeValue<double>, IComparable, IStringConvertibleValue {
+  public class DoubleValue : ValueTypeValue<double>, IComparable, IStringConvertibleValue {
     public DoubleValue() : base() { }
     public DoubleValue(double value) : base(value) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      DoubleValue clone = new DoubleValue(Value);
+      DoubleValue clone = new DoubleValue(value);
       cloner.RegisterClonedObject(this, clone);
       return clone;
@@ -43,5 +43,5 @@
     }
 
-    public int CompareTo(object obj) {
+    public virtual int CompareTo(object obj) {
       DoubleValue other = obj as DoubleValue;
       if (other != null)
@@ -51,6 +51,5 @@
     }
 
-    #region IStringConvertibleValue Members
-    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       double val;
       bool valid = double.TryParse(value, out val);
@@ -65,8 +64,8 @@
       return valid;
     }
-    string IStringConvertibleValue.GetValue() {
+    protected virtual string GetValue() {
       return Value.ToString("r");  // round-trip format
     }
-    bool IStringConvertibleValue.SetValue(string value) {
+    protected virtual bool SetValue(string value) {
       double val;
       if (double.TryParse(value, out val)) {
@@ -77,4 +76,15 @@
       }
     }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj	(revision 3054)
@@ -95,6 +95,4 @@
     </Reference>
     <Reference Include="System.Data" />
-    <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml" />
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.Data/3.3/IntArray.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/IntArray.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/IntArray.cs	(revision 3054)
@@ -28,23 +28,16 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class IntArray : ValueTypeArray<int>, IStringConvertibleArray {
+  public class IntArray : ValueTypeArray<int>, IStringConvertibleArray {
     public IntArray() : base() { }
     public IntArray(int length) : base(length) { }
     public IntArray(int[] elements) : base(elements) { }
-    private IntArray(IntArray elements) : base(elements) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      IntArray clone = new IntArray(this);
+      IntArray clone = new IntArray(array);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    #region IStringConvertibleArray Members
-    int IStringConvertibleArray.Length {
-      get { return Length; }
-      set { Length = value; }
-    }
-
-    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       int val;
       bool valid = int.TryParse(value, out val);
@@ -59,8 +52,8 @@
       return valid;
     }
-    string IStringConvertibleArray.GetValue(int index) {
+    protected virtual string GetValue(int index) {
       return this[index].ToString();
     }
-    bool IStringConvertibleArray.SetValue(string value, int index) {
+    protected virtual bool SetValue(string value, int index) {
       int val;
       if (int.TryParse(value, out val)) {
@@ -71,4 +64,19 @@
       }
     }
+
+    #region IStringConvertibleArray Members
+    int IStringConvertibleArray.Length {
+      get { return Length; }
+      set { Length = value; }
+    }
+    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleArray.GetValue(int index) {
+      return GetValue(index);
+    }
+    bool IStringConvertibleArray.SetValue(string value, int index) {
+      return SetValue(value, index);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/IntMatrix.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/IntMatrix.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/IntMatrix.cs	(revision 3054)
@@ -28,27 +28,16 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class IntMatrix : ValueTypeMatrix<int>, IStringConvertibleMatrix {
+  public class IntMatrix : ValueTypeMatrix<int>, IStringConvertibleMatrix {
     public IntMatrix() : base() { }
     public IntMatrix(int rows, int columns) : base(rows, columns) { }
     public IntMatrix(int[,] elements) : base(elements) { }
-    private IntMatrix(IntMatrix elements) : base(elements) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      IntMatrix clone = new IntMatrix(this);
+      IntMatrix clone = new IntMatrix(matrix);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    #region IStringConvertibleMatrix Members
-    int IStringConvertibleMatrix.Rows {
-      get { return Rows; }
-      set { Rows = value; }
-    }
-    int IStringConvertibleMatrix.Columns {
-      get { return Columns; }
-      set { Columns = value; }
-    }
-
-    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       int val;
       bool valid = int.TryParse(value, out val);
@@ -63,8 +52,8 @@
       return valid;
     }
-    string IStringConvertibleMatrix.GetValue(int rowIndex, int columIndex) {
+    protected virtual string GetValue(int rowIndex, int columIndex) {
       return this[rowIndex, columIndex].ToString();
     }
-    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+    protected virtual bool SetValue(string value, int rowIndex, int columnIndex) {
       int val;
       if (int.TryParse(value, out val)) {
@@ -75,4 +64,23 @@
       }
     }
+
+    #region IStringConvertibleMatrix Members
+    int IStringConvertibleMatrix.Rows {
+      get { return Rows; }
+      set { Rows = value; }
+    }
+    int IStringConvertibleMatrix.Columns {
+      get { return Columns; }
+      set { Columns = value; }
+    }
+    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleMatrix.GetValue(int rowIndex, int columIndex) {
+      return GetValue(rowIndex, columIndex);
+    }
+    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+      return SetValue(value, rowIndex, columnIndex);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/IntValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/IntValue.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/IntValue.cs	(revision 3054)
@@ -29,15 +29,15 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class IntValue : ValueTypeValue<int>, IComparable, IStringConvertibleValue {
+  public class IntValue : ValueTypeValue<int>, IComparable, IStringConvertibleValue {
     public IntValue() : base() { }
     public IntValue(int value) : base(value) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      IntValue clone = new IntValue(Value);
+      IntValue clone = new IntValue(value);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    public int CompareTo(object obj) {
+    public virtual int CompareTo(object obj) {
       IntValue other = obj as IntValue;
       if (other != null)
@@ -47,6 +47,5 @@
     }
 
-    #region IStringConvertibleValue Members
-    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       int val;
       bool valid = int.TryParse(value, out val);
@@ -61,8 +60,8 @@
       return valid;
     }
-    string IStringConvertibleValue.GetValue() {
+    protected virtual string GetValue() {
       return Value.ToString();
     }
-    bool IStringConvertibleValue.SetValue(string value) {
+    protected virtual bool SetValue(string value) {
       int val;
       if (int.TryParse(value, out val)) {
@@ -73,4 +72,15 @@
       }
     }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/StringArray.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/StringArray.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/StringArray.cs	(revision 3054)
@@ -31,11 +31,11 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class StringArray : Item, IEnumerable, IStringConvertibleArray {
+  public class StringArray : Item, IEnumerable, IStringConvertibleArray {
     [Storable]
-    private string[] array;
+    protected string[] array;
 
-    public int Length {
+    public virtual int Length {
       get { return array.Length; }
-      private set {
+      protected set {
         if (value != Length) {
           Array.Resize<string>(ref array, value);
@@ -44,5 +44,5 @@
       }
     }
-    public string this[int index] {
+    public virtual string this[int index] {
       get { return array[index]; }
       set {
@@ -70,12 +70,9 @@
         array[i] = elements[i] == null ? string.Empty : elements[i];
     }
-    private StringArray(StringArray elements) {
-      if (elements == null) throw new ArgumentNullException();
-      array = (string[])elements.array.Clone();
-    }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      StringArray clone = new StringArray(this);
+      StringArray clone = new StringArray();
       cloner.RegisterClonedObject(this, clone);
+      clone.array = (string[])array.Clone();
       return clone;
     }
@@ -93,15 +90,9 @@
     }
 
-    public IEnumerator GetEnumerator() {
+    public virtual IEnumerator GetEnumerator() {
       return array.GetEnumerator();
     }
 
-    #region IStringConvertibleArray Members
-    int IStringConvertibleArray.Length {
-      get { return Length; }
-      set { Length = value; }
-    }
-
-    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       if (value == null) {
         errorMessage = "Invalid Value (string must not be null)";
@@ -112,8 +103,8 @@
       }
     }
-    string IStringConvertibleArray.GetValue(int index) {
+    protected virtual string GetValue(int index) {
       return this[index];
     }
-    bool IStringConvertibleArray.SetValue(string value, int index) {
+    protected virtual bool SetValue(string value, int index) {
       if (value != null) {
         this[index] = value;
@@ -123,6 +114,7 @@
       }
     }
+
     public event EventHandler<EventArgs<int>> ItemChanged;
-    private void OnItemChanged(int index) {
+    protected virtual void OnItemChanged(int index) {
       if (ItemChanged != null)
         ItemChanged(this, new EventArgs<int>(index));
@@ -130,9 +122,24 @@
     }
     public event EventHandler Reset;
-    private void OnReset() {
+    protected virtual void OnReset() {
       if (Reset != null)
         Reset(this, EventArgs.Empty);
       OnToStringChanged();
     }
+
+    #region IStringConvertibleArray Members
+    int IStringConvertibleArray.Length {
+      get { return Length; }
+      set { Length = value; }
+    }
+    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleArray.GetValue(int index) {
+      return GetValue(index);
+    }
+    bool IStringConvertibleArray.SetValue(string value, int index) {
+      return SetValue(value, index);
+    }
     #endregion
   }
